"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var Calendar_1 = __importDefault(require("@steroidsjs/core/ui/content/Calendar"));
var CalendarType_1 = __importDefault(require("@steroidsjs/core/ui/content/CalendarSystem/enums/CalendarType"));
var AsideHeader_1 = __importDefault(require("./AsideHeader"));
var AsideCalendars_1 = __importDefault(require("./AsideCalendars"));
var ContentHeader_1 = __importDefault(require("./ContentHeader"));
var MonthGrid_1 = __importDefault(require("./MonthGrid"));
var WeekGrid_1 = __importDefault(require("./WeekGrid"));
function CalendarSystemView(props) {
    var bem = (0, useBem_1["default"])('CalendarSystemView');
    var calendarTypeGrids = react_1["default"].useMemo(function () {
        var _a;
        return (_a = {},
            _a[CalendarType_1["default"].MONTH] = react_1["default"].createElement(MonthGrid_1["default"], __assign({}, props.monthGridProps)),
            _a[CalendarType_1["default"].WEEK] = react_1["default"].createElement(WeekGrid_1["default"], __assign({}, props.weekGridProps)),
            _a);
    }, [props.monthGridProps, props.weekGridProps]);
    return (react_1["default"].createElement("div", { className: bem(bem.block(), props.className), style: props.style },
        react_1["default"].createElement("aside", { className: bem.element('aside') },
            react_1["default"].createElement(AsideHeader_1["default"], { onClick: props.openCreateModal, className: bem.element('aside-header') }),
            react_1["default"].createElement(Calendar_1["default"], { showFooter: false, onMonthChange: props.onInnerCalendarChangeMonth }),
            react_1["default"].createElement(AsideCalendars_1["default"], { eventGroups: props.eventGroups, eventGroupsTitle: props.eventGroupsTitle, onChangeEventGroupsIds: props.onChangeEventGroupsIds, openCreateEventGroupModal: props.openCreateEventGroupModal })),
        react_1["default"].createElement("div", { className: bem.element('content') },
            react_1["default"].createElement(ContentHeader_1["default"], { dateToDisplay: props.dateToDisplay, onChangeCalendarType: props.handleCalendarTypeChange, handleControlClick: props.handleControlClick }),
            calendarTypeGrids[props.calendarType])));
}
exports["default"] = CalendarSystemView;
